config/routes.rb
class SubdomainConstraint
  def self.matches?(request)
    subdomains = %w{ www admin}
    request.subdomain.present? && subdomains.exclude?(request.subdomain)
  end
end

Rails.application.routes.draw do
  constraints SubdomainConstraint do
    get '/info', to: 'companies#show'
    post 'employee/create', to: 'employees#create'
  end
  get 'companies/new'
  post 'companies/create'
  devise_for :users
  root to: 'companies#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/company.rb
class Company < ApplicationRecord
  after_create :create_tenant
 
  def create_tenant
    Apartment::Tenant.create(subdomain)
  end
end

app/models/employee.rb
class Employee < ApplicationRecord
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  #protect_from_forgery with: :exception
  #before_action :authenticate_user!
end

app/controllers/companies_controller.rb
class CompaniesController < ApplicationController
  def index
    @companies = Company.all
  end
 
  def new
    @company = Company.new
  end

  def show
    @company = Company.find_by(subdomain: request.subdomain)
    @employees = Employee.all
    @empoyee = Employee.new
  end
 
  def create
    @company = Company.new(company_params)
    respond_to do |format|
      if @company.save
        format.html { redirect_to root_path, notice: 'Company criada com sucesso' }
      else
        format.html { render :new, error: 'Não foi possível criar a Company'}
      end
    end
  end
 
  private
  def company_params
    params.require(:company).permit(:name, :description, :subdomain)
  end
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
  def create
    @employee = Employee.new(employee_params)
    respond_to do |format|
      if @employee.save
        format.html { redirect_to info_path, notice: 'Funcionário adicionado' }
      end
    end
  end
 
  private
  def employee_params
    params.require(:employee).permit(:name, :job)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/companies_helper.rb
module CompaniesHelper
end

app/helpers/employees_helper.rb
module EmployeesHelper
end

app/views/companies/index.html.erb
<div class="page-header">
  <h1>
    Companies
    <%= link_to t('.new', :default => t("helpers.links.new")),
                companies_new_path,
                :class => 'btn btn-primary' %>
  </h1>
</div>
<div class="companies row">
  <div class="col-lg-10 col-lg-offset-1">
    <table class="table table-striped">
      <thead>
        <tr>
          <th>Name</th>
          <th>Subdomain</th>
        </tr>
      </thead>
      <tbody>
        <% @companies.each do |company| %>
          <tr>
            <td><%= company.name %></td>
            <td><%= company.subdomain %></td>
          </tr>
        <% end %>
      </tbody>
    </table>
  </div>
</div>

app/views/companies/new.html.erb
<div class="page-header">
  <h1>New Company</h1>
</div>
 
<div class="form row">
  <div class="col-lg-10">
    <%= form_with  url: companies_create_path, local: true, :html => { :class => "form-horizontal thought" } do |form| %>
      <% if @company.errors.any? %>
        <div id="error_expl" class="panel panel-danger">
          <div class="panel-heading">
            <h3 class="panel-title"><%= pluralize(@thought.errors.count, "error") %> prohibited this thought from being saved:</h3>
          </div>
          <div class="panel-body">
            <ul>
            <% @company.errors.full_messages.each do |msg| %>
              <li><%= msg %></li>
            <% end %>
            </ul>
          </div>
        </div>
      <% end %>
      <div class="form-group">
        <%= form.label :name, :class => 'control-label col-lg-2' %>
        <div class="col-lg-10">
          <%= form.text_field :name, name: 'company[name]',:class => 'form-control' %>
        </div>
        <%= form.error_span(:name) %>
      </div>
      <div class="form-group">
        <%= form.label :description, :class => 'control-label col-lg-2' %>
        <div class="col-lg-10">
          <%= form.text_area :description, name: 'company[description]',:class => 'form-control' %>
        </div>
        <%= form.error_span(:description) %>
      </div>
      <div class="form-group">
        <%= form.label :subdomain, :class => 'control-label col-lg-2' %>
        <div class="col-lg-10">
          <%= form.text_field :subdomain, name: 'company[subdomain]',:class => 'form-control' %>
        </div>
        <%= form.error_span(:subdomain) %>
      </div>
 
      <div class="form-group">
        <div class="col-lg-offset-2 col-lg-10">
          <%= form.submit 'Save', :class => 'btn btn-primary' %>
          <%= link_to t('.cancel', :default => t("helpers.links.cancel")),
                    root_path, :class => 'btn btn-default' %>
        </div>
      </div>
    <% end %>
  </div>
</div>

app/views/companies/show.html.erb
<div class="info row">
  <div class="col-lg-10 col-lg-offset-1">
    <div class="page-header">
      <h1> <%= @company.name %></h1>
    </div>
    <p>This company is <%= @company.description %></p>
    <%= form_with  url: employee_create_path, local: true, :html => { :class => "form-inline" } do |form| %>
      <div class="form-group">
        <%= form.label :name, :class => 'control-label' %>
        <%= form.text_field :name, name: 'employee[name]',:class => 'form-control' %>
      </div>
      <div class="form-group">
        <%= form.label :job, :class => 'control-label' %>
        <%= form.text_field :job, name: 'employee[job]',:class => 'form-control' %>
      </div>
      <div class="form-group">
        <%= form.submit 'Add', :class => 'btn btn-primary' %>
      </div>
    <% end %>
    <% if @employees.size > 0 %>
    <h2> Employees</h2>
      <table class="table table-striped">
        <thead>
          <tr>
            <th>Name</th>
            <th>Job</th>
          </tr>
        </thead>
        <tbody>
          <% @employees.each do |employee| %>
            <tr>
              <td><%= employee.name %></td>
              <td><%= employee.job %></td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% end %>
  </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CompanyMultitenancy</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>